using System;
using System.Collections;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Reflection;
using System.Threading;
using System.Web.Mail;

namespace NetLauncher
{
	/// <summary>
	/// [gɔzuꂽAZuƃ[JLbV̐ȂA
	/// AZu̎s𐧌䂷B
	/// [JLbV͂̃AZuzuꂽfBNglocalfBNg
	/// AZuɍ쐬B
	/// Kł́ÃAZuzuꂽfBNgapplicationList.xml𗘗pB
	/// </summary>
	public class WebLauncher : IEnumerable
	{
		private string baseDirectory;
		private applicationList configFile;
		private WebFile configProxy;
		private Hashtable applications;

		private event EventHandler beginDownload;
		private event EventHandler endDownload;
		private event EventHandler loadAppDomain;
		private event EventHandler unloadAppDomain;

		/// <summary>
		/// ̃AZuƓfBNgɔzuꂽapplicationList.xmlǂݍށB
		/// ݂ȂΒɃLbVpfBNg쐬B
		/// Lqꂽ[gzXgɍŐVapplicationList.xml݂ΒusB
		/// o^ĂAZũvNV쐬B
		/// </summary>
		/// <exception cref="System.IO.FileNotFoundException">applicationList.xml݂ȂB</exception>
		/// <exception cref="System.Net.WebException">[g̎擾ɎsB</exception>"
		/// <exception cref="ConfigurationException">applicationList.xml̓esB</exception>"
		public WebLauncher()
			: this(new FileInfo(new Uri(Assembly.GetExecutingAssembly().CodeBase).LocalPath).DirectoryName)
		{
			
		}

		/// <summary>
		/// wfBNgɔzuꂽapplicationList.xmlǂݍށB
		/// ݂ȂΒɃLbVpfBNg쐬B
		/// Lqꂽ[gzXgɍŐVapplicationList.xml݂ΒusB
		/// o^ĂAZũvNV쐬B
		/// </summary>
		/// <param name="confDirectory">applicationList.xmlzuꂽfBNg</param>
		/// <exception cref="System.IO.FileNotFoundException">applicationList.xml݂ȂB</exception>
		/// <exception cref="System.Net.WebException">[g̎擾ɎsB</exception>"
		/// <exception cref="ConfigurationException">applicationList.xml̓esB</exception>"
		public WebLauncher(string confDirectory)
		{
			FileInfo fi = new FileInfo(new Uri(Assembly.GetExecutingAssembly().CodeBase).LocalPath);
			baseDirectory = fi.DirectoryName;
			Directory.CreateDirectory(baseDirectory + "\\local");
			configProxy = new WebFile("applicationList.xml", confDirectory);
			ReadConfig();	// ǂݍ݃G[ɂ͂ConfigurationExceptionX[B
			UpdateConfig(); // XV󋵂`FbNB
		}

		/// <summary>
		/// applicationList.xml̍XV󋵂`FbNAXVς݂łΎ擾B
		/// Ăяo͐IALbVĂApplicatioñCX^XGetEnumerator()
		/// pāA擾KvB
		/// </summary>
		/// <exception cref="System.IO.FileNotFoundException">applicationList.xml݂ȂB</exception>
		/// <exception cref="System.Net.WebException">[g̎擾ɎsB</exception>"
		/// <exception cref="ConfigurationException">applicationList.xml̓esB</exception>"
		public void UpdateConfig()
		{
			Debug.Assert(configProxy != null && configProxy.Exists);
			Debug.Assert(configFile != null && configFile.host != null && configFile.host.Length > 0);

			UriBuilder ub = new UriBuilder(Uri.UriSchemeHttp, String.Empty);
			foreach (HostType host in configFile.host)
			{
				ub.Host = host.name;
				ub.Path = host.listPath;
				try
				{
					Uri uri = ub.Uri;
					if (configProxy.NeedUpdate(uri))
					{
						configProxy.Replace(uri, true);
						ReadConfig();	// ǂݍ݃G[ɂ͂ConfigurationExceptionX[B
					}
					break;
				}
				catch (WebException e)
				{
					if (e.Status == WebExceptionStatus.ProtocolError)
					{
						throw new ConfigurationException("[g̍\G[łB(" + e.Message + ")", e);
					}
				}
			}

			Debug.Assert(configFile != null && configFile.host != null && configFile.host.Length > 0);
		}

		/// <summary>
		/// wAvP[VNBKvł΃_E[hsB
		/// </summary>
		/// <param name="app">AvP[V</param>
		/// <param name="checkDate">Ƀ_E[hς݂łĂt`FbNA
		///                         ŐV݂΃_E[ĥłtruew</param>
		/// <exception cref="System.Net.WebException">_E[hɎsꍇɃX[B</exception>
		/// <exception cref="ConfigurationException">w肳ꂽAvP[VȃAZuł͖</exception>"
		public void Launch(Application app, bool checkDate)
		{
			AssemblyFile asm = app.AssemblyFile;
			bool needDownload = !asm.Exists;
			if (asm.Exists && checkDate)
			{
				needDownload = asm.NeedUpdate;
			}
			if (needDownload)
			{
				OnBeginDownload(app);
				asm.Download();
				OnEndDownload(app);
			}
			Launch(app);
		}

		private void Launch(Application app)
		{
			Debug.Assert(app.AssemblyFile.Exists);
			Launcher l = new Launcher(app.Name, baseDirectory, app.AssemblyFile, this);
			Thread t = new Thread(new System.Threading.ThreadStart(l.Execute));
			t.Start();
		}

		/// <summary>
		/// [JLbV̎wAvP[VNB
		/// </summary>
		/// <param name="app">AvP[V</param>
		/// <exception cref="ConfigurationException">w肳ꂽAvP[VȃAZuł͖</exception>"
		/// <exception cref="NotReadyException">w肳ꂽAvP[VLbV</exception>
		public void LaunchFromLocal(Application app)
		{
			AssemblyFile asm = app.AssemblyFile;
			if (!asm.Exists)
			{
				throw new NotReadyException(app.Name + "̓[JɕۑĂ܂B");
			}
			
			Launch(app);
		}

		[Serializable]
		private class Launcher 
		{
			private AppDomain appDomain;
			private System.Security.Policy.Evidence evidence;
			private string assemblyFile;
			private string applicationName;
			private string sendto;
			private string from;
			private string smtpServer;
			[NonSerialized]	private WebLauncher outer;
			private bool alreadyUnloaded;
			internal Launcher(string appName, string baseDirectory, AssemblyFile asm, WebLauncher initOuter)
			{
				Debug.Assert(initOuter != null);
				Debug.Assert(Directory.Exists(baseDirectory));
				Debug.Assert(asm != null && File.Exists(asm.LocalFileName));

				outer = initOuter;
				assemblyFile = asm.LocalFileName;
				applicationName = appName;
				sendto = outer.configFile.contact.administrator;
				from = outer.configFile.contact.user;
				smtpServer = outer.configFile.contact.smtpServer;
				AppDomainSetup setup = new AppDomainSetup();
				setup.ApplicationBase = baseDirectory;
				setup.ApplicationName = appName;
				setup.PrivateBinPath = asm.LocalDirectory;
				setup.ShadowCopyFiles = "false";
				System.Security.Policy.Evidence baseEvidence = AppDomain.CurrentDomain.Evidence;
				evidence = new System.Security.Policy.Evidence(baseEvidence);
				appDomain = AppDomain.CreateDomain(appName, evidence, setup);
				appDomain.Load(Assembly.GetExecutingAssembly().GetName(), evidence);
				appDomain.DomainUnload += new EventHandler(UnloadHandler);
			}

			internal AppDomain CreatedDomain
			{
				get { return appDomain; }
			}

			internal void Execute()
			{
				Debug.Assert(appDomain != null);
				Debug.Assert(File.Exists(assemblyFile));;

				outer.OnLoadAppDomain(appDomain);

				try
				{
					appDomain.DoCallBack(new CrossAppDomainDelegate(ExecuteAssembly));
				}
				catch (Exception)
				{
					// IɁAOƂȂ
				}

				outer.OnUnloadAppDomain(appDomain);
				if (!alreadyUnloaded)
				{
					try
					{
						AppDomain.Unload(appDomain);
					}
					catch (AppDomainUnloadedException)
					{
						// Unloadς݂̏ꍇ
					}
					catch (CannotUnloadAppDomainException)
					{
					}
				}
			}

			// ̃\bh́AAppDomainŎsB
			// ͗Onh𐳂tbN邽߂łB(X^eBbNAppDomainP)
			public void ExecuteAssembly()
			{
#if SHOWAPPDOMAIN
				System.Windows.Forms.MessageBox.Show(AppDomain.CurrentDomain.FriendlyName +
					":" + AppDomain.GetCurrentThreadId());
#endif
				// Windows.Forms͓ŃgbvȂOp̃nh쐬A
				// AvP[VÎŁAtbNB
				System.Windows.Forms.Application.ThreadException += new ThreadExceptionEventHandler(OnThreadException);
				try
				{
					AppDomain.CurrentDomain.ExecuteAssembly(assemblyFile, evidence);
				}
				catch (Exception e)
				{
					if (sendto != null && sendto != String.Empty)
					{
						SendMail(sendto, (e is ForceExitException) ? e.InnerException : e);
					}
				}
			}

			// ̃Cxgnh́AAppDomainł̌ĂяoƂȂ邽߁A[eBOΏۂł͖B
			private void OnThreadException(object sender, ThreadExceptionEventArgs t) 
			{
#if SHOWAPPDOMAIN
				System.Windows.Forms.MessageBox.Show(AppDomain.CurrentDomain.FriendlyName + t.Exception.Message + ":2");
#endif
				throw new ForceExitException("AvP[VG[", t.Exception);
			}

			private class ForceExitException : Exception
			{
				internal ForceExitException(string msg, Exception e) :
					base(msg, e)
				{
				}
			}

			// ̃\bhpublicȂ̂́AAppDomainNXĂяo=[eBȎΏۂƂȂ邩łB
			public void UnloadHandler(object sender, EventArgs e)
			{
				// ɂׂ͓AƂ肠̖ڈƂĂpȂ߁AȂB
				alreadyUnloaded = true;
				// ALauncherNXSerializableƂĎꍇAouterSerializablełȂ߁A
				// łnullƂȂB̂߁AOnUnloadAppDomainĂяoƂ͂łȂB
				// tɁAMarshaByRefObjectƂĎꍇAouter.OnUnloadAppDomaiňĂяo
				// \ł邪AExecuteAssemblyɎsꍇɂ́ÃCxgnhgĂяoȂB
				// ̏ԂƂȂ̂́AꕔAssemblyȂꍇłB
				// A̗̎OFileNotFoundExceptionłAꂪExecuteAssemblyɂ̂A
				// Ƃs̃AvP[Vɂ̂͋ʂłȂBāAĂяô
				// B
			}

			private void SendMail(string to, Exception e)
			{
				if (smtpServer != null && smtpServer != String.Empty)
				{
					System.Web.Mail.SmtpMail.SmtpServer = smtpServer;
				}
				string tempf = Path.GetTempFileName();
				string temptxt = Path.ChangeExtension(tempf, ".txt");
				File.Delete(tempf);
				using (TextWriter wtr = new StreamWriter(temptxt, false, System.Text.Encoding.Default))
				{
					wtr.Write(e.StackTrace);
				}
				System.Web.Mail.MailMessage mail = new System.Web.Mail.MailMessage();
				mail.Subject = "[exception]" + applicationName;
				mail.To = to;
				mail.Attachments.Add(new System.Web.Mail.MailAttachment(temptxt));
				// ŎꍇɂISP̃[AhX̂悤ɁAT[ot\
				// AhXw肷KvB
				if (from == null || from == String.Empty)
				{
					mail.From = Environment.UserName + "@" + Environment.MachineName;
				}
				else
				{
					mail.From = from;
				}
				System.Text.StringBuilder sb = new System.Text.StringBuilder(1000);
				sb.Append(DateTime.Now);
				sb.Append('\n');
				sb.Append(assemblyFile);
				sb.Append('\n');
				sb.Append(e.Message);
				sb.Append('\n');
				sb.Append("---Exception Source----------------\n");
				sb.Append(e.Source);
				sb.Append('\n');
				sb.Append("---System Information--------------\n");
				sb.Append(Environment.Version);
				sb.Append('\n');
				sb.Append(Environment.OSVersion);
				sb.Append('\n');
				mail.Body = sb.ToString();
				System.Web.Mail.SmtpMail.Send(mail);
				File.Delete(temptxt);
			}
		}

		protected void OnBeginDownload(Application app)
		{
			if (beginDownload != null)
			{
				beginDownload(this, new DownloadEventArgs(app));
			}
		}

		protected void OnEndDownload(Application app)
		{
			if (endDownload != null)
			{
				endDownload(this, new DownloadEventArgs(app));
			}
		}

		protected void OnLoadAppDomain(AppDomain domain)
		{
			if (loadAppDomain != null)
			{
				loadAppDomain(this, new AppDomainEventArgs(domain));
			}
		}

		protected void OnUnloadAppDomain(AppDomain domain)
		{
			if (unloadAppDomain != null)
			{
				unloadAppDomain(this, new AppDomainEventArgs(domain));
			}
		}

		/// <summary>
		/// _E[hJnCxgnho^܂B
		/// ̃CxgLaunch\bȟĂяoɁA_E[hKvƂȂꍇ
		/// Launche\bhĂяoXbhŒʒm܂B
		/// </summary>
		/// <param name="e">_E[hJnCxg̃fQ[g</param>
		public void AddOnBeginDownload(EventHandler e)
		{
			beginDownload += e;
		}

		/// <summary>
		/// _E[hJnCxgnho^܂B
		/// </summary>
		/// <param name="e">_E[hJnCxg̃fQ[g</param>
		public void RemoveOnBeginDownload(EventHandler e)
		{
			beginDownload -= e;
		}

		/// <summary>
		/// _E[hICxgnho^܂B
		/// ̃CxgLaunch\bȟĂяoɁA_E[hKvƂȂꍇ
		/// Launche\bhĂяoXbhŒʒm܂B
		/// </summary>
		/// <param name="e">_E[hICxg̃fQ[g</param>
		public void AddOnEndDownload(EventHandler e)
		{
			endDownload += e;
		}

		/// <summary>
		/// _E[hICxgnho^܂B
		/// </summary>
		/// <param name="e">_E[hICxg̃fQ[g</param>
		public void RemoveOnEndDownload(EventHandler e)
		{
			endDownload -= e;
		}

		/// <summary>
		/// AppDomain[hCxgnho^܂B
		/// ̃Cxg͓o^̃XbhƂ͈قȂXbhŒʒm܂B
		/// </summary>
		/// <param name="e">AppDomain[hCxg̃fQ[g</param>
		public void AddOnLoadAppDomain(EventHandler e)
		{
			loadAppDomain += e;
		}

		/// <summary>
		/// AppDomain[hCxgnho^܂B
		/// </summary>
		/// <param name="e">AppDomain[hCxg̃fQ[g</param>
		public void RemoveOnLoadAppDomain(EventHandler e)
		{
			loadAppDomain -= e;
		}

		/// <summary>
		/// AppDomainA[hCxgnho^܂B
		/// ̃Cxg͓o^̃XbhƂ͈قȂXbhŒʒm܂B
		/// </summary>
		/// <param name="e">AppDomainA[hCxg̃fQ[g</param>
		public void AddOnUnloadAppDomain(EventHandler e)
		{
			unloadAppDomain += e;
		}

		/// <summary>
		/// AppDomainA[hCxgnho^܂B
		/// </summary>
		/// <param name="e">AppDomainA[hCxg̃fQ[g</param>
		public void RemoveOnUnloadAppDomain(EventHandler e)
		{
			unloadAppDomain -= e;
		}

		/// <summary>
		/// applicationList.xmlǂݍ݁A\擾B
		/// </summary>
		/// <exception cref="ConfigurationException">XML\G[I/OG[ɃX[B</exception>
		private void ReadConfig()
		{
			Debug.Assert(configProxy != null);

			FileStream stm = configProxy.InputStream;
			try
			{
				System.Xml.Serialization.XmlSerializer serializer = new System.Xml.Serialization.XmlSerializer(typeof(applicationList));
				configFile = (applicationList)serializer.Deserialize(stm);
			}
			catch (Exception e)
			{
				throw new ConfigurationException(e.Message, e);
			}
			finally 
			{
				stm.Close();
			}
			if (configFile.host == null || configFile.host.Length == 0)
			{
				throw new ConfigurationException("[gzXgo^łB");
			}
			// [T[ow肳Ăݒ肷B
			if (configFile.contact.smtpServer != null && configFile.contact.smtpServer != String.Empty)
			{
				System.Web.Mail.SmtpMail.SmtpServer = configFile.contact.smtpServer;
			}

			// AZuXg`FbNB
			SetupAssemblies();

			Debug.Assert(applications != null);
			Debug.Assert(configFile != null);
		}

		/// <summary>
		/// o^ĂAvP[V(WebLauncher.Application)̗񋓂ԂB
		/// </summary>
		/// <returns>o^ĂAvP[V(WebLauncher.Application)̗񋓁B</returns>
		public IEnumerator GetEnumerator()
		{
			Debug.Assert(applications != null);

			return applications.Values.GetEnumerator();
		}

		private void SetupAssemblies()
		{
			Debug.Assert(configFile != null);

			if (applications == null)
			{
				applications = new Hashtable();
			}
			else
			{
				applications.Clear();
			}
			if (configFile.application == null || configFile.application.Length <= 0)
			{
				return;
			}

			ArrayList hosts = new ArrayList(configFile.host.Length);
			foreach (HostType host in configFile.host)
			{
				hosts.Add(host.name);
			}
			foreach (ApplicationType app in configFile.application)
			{
				AssemblyFile asm = new AssemblyFile(app.mainModule, baseDirectory + "\\local\\" + app.name, app.baseDirectory, hosts);
				applications.Add(app.name, new Application(app.name, app.description, asm));
			}
		}

		/// <summary>
		/// o^ĂAvP[VB
		/// </summary>
		public class Application
		{
			private string name;
			private string description;
			private AssemblyFile assemblyFile;
			internal Application(string initName, string initDescr, AssemblyFile initAssembly)
			{
				name = initName;
				description = initDescr;
				assemblyFile = initAssembly;
			}
			/// <summary>
			/// AvP[VԂB
			/// </summary>
			public String Name
			{
				get { return name; }
			}
			/// <summary>
			/// AvP[V̐ԂB
			/// </summary>
			public string Description
			{
				get { return description; }
			}
			/// <summary>
			/// AvP[ṼACRԂB
			/// AvP[V܂_E[hĂȂnullԂB
			/// gṕADispose\bhĂяoĔp邱Ƃ]܂B
			/// </summary>
			public System.Drawing.Icon Icon
			{
				get { return assemblyFile.Icon; }
			}

			/// <summary>
			/// wAvP[V[JɃLbVς݂𔻒肷B
			/// </summary>
			/// <param name="appName">肷AvP[V</param>
			/// <returns>LbVς݂ȂtrueԂB</returns>
			/// <exception cref="System.ArgumentException">w肳ꂽAvP[Vo^</exception>
			public bool CacheExists
			{
				get { return assemblyFile.Exists; }
			}			

			internal AssemblyFile AssemblyFile 
			{
				get { return assemblyFile; }
			}
		}

		/// <summary>
		/// BeginDownloadEndDownload̊eCxg̈B
		/// ΏۂƂȂAvP[Vi[ĂB
		/// </summary>
		public class DownloadEventArgs : EventArgs
		{
			private Application application;
			internal DownloadEventArgs(Application initApp)
			{
				application = initApp;
			}
			/// <summary>
			/// Cxg̒ʒmΏۂƂȂAvP[VԂB
			/// </summary>
			public Application Application
			{
				get { return application; }
			}
		}

		/// <summary>
		/// LoadAppDomainUnloadAppDomain̊eCxg̈B
		/// ΏۂƂȂAppDomaini[ĂB
		/// </summary>
		public class AppDomainEventArgs : EventArgs
		{
			private AppDomain domain;
			internal AppDomainEventArgs(AppDomain initDomain)
			{
				domain = initDomain;
			}
			/// <summary>
			/// Cxg̒ʒmΏۂƂȂAppDomainԂB
			/// </summary>
			public AppDomain AppDomain
			{
				get { return domain; }
			}
		}
	}

	/// <summary>
	/// ApplicationList.xml̓esȏꍇɃX[B
	/// </summary>
	public class ConfigurationException : InvalidOperationException
	{
		internal ConfigurationException(string message) 
			: base(message)
		{
		}
		internal ConfigurationException(string message, Exception cause)
			: base(message, cause)
		{
		}
	}

	/// <summary>
	/// _E[hς݃AvP[V̋Nv󂯂ꍇɃX[B
	/// </summary>
	public class NotReadyException : InvalidOperationException
	{
		internal NotReadyException(string message)
			: base(message)
		{
		}
	}
}
